#!/bin/python3

import pysam
import sys

outfile=pysam.AlignmentFile(sys.argv[2], template=pysam.AlignmentFile(sys.argv[1], "rb"), mode ="wb") 

def extractNMFromBam(bam):
	'''
	loop bam and get the edit distance to the ref genome stored in the NM tag 
	scale by aligned read length
	'''
	readselection = [] 
	samfile = pysam.AlignmentFile(bam, "rb")
	if not samfile.has_index():
		pysam.index(bam)
		samfile = pysam.AlignmentFile(bam, "rb")
	for read in samfile.fetch():
		#print(read)
		score = read.get_tag("NM")/read.query_alignment_length
		if score < 0.2: #80% cutoff
			readselection.append(score)
			outfile.write(read)
	return readselection
	#return [read.get_tag("NM")/read.query_alignment_length for read in samfile.fetch()]
	

df = extractNMFromBam(sys.argv[1])
print(df)
