#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Wed Oct  6 15:15:16 2021

@author: weichan
"""

import re

import argparse


custom = argparse.ArgumentParser("Create a specific HLA fasta file.",add_help=False)


custom.add_argument('-h', '--help', action='help', default=argparse.SUPPRESS,
                    help='Show this help message and exit.')
custom.add_argument("-p",'--hla_types', dest="pattern", required = True, action="append", nargs="*", help="Input hla types in list format")
custom.add_argument("-i",'--input_master_fasta', dest="input_fasta", required = True, help="Output prefix")
custom.add_argument("-o",'--output_fasta', dest="output_fasta", action="append", nargs="*", required = False, help="Output prefix")
args = custom.parse_args()

#fasta = open("/home/weichan/RNASeqPipeline/rnaseqpipeline/Source/newhla_nuc.fasta")
fasta = open(args.input_fasta)

dic = {}
cur_scaf = ''
cur_seq = []
for line in fasta:
    if line.startswith(">") and cur_scaf == '':
        cur_scaf = line.split(' ')[0]
        cur_scaf = cur_scaf.replace("*", "")
        #print(cur_scaf)
    elif line.startswith(">") and cur_scaf != '':
        cur_scaf = cur_scaf.replace("*", "")
        #print(cur_scaf)
        dic[cur_scaf] = ''.join(cur_seq)
        cur_scaf = line.split(' ')[0]
        cur_seq = []
    else:
        cur_seq.append(line.rstrip())
dic[cur_scaf] = ''.join(cur_seq)

#print(args.output_fasta)
for obj in args.output_fasta[0]:
	#print(obj)
	fasta = open(obj, "w")

	new_dic= dict()
	#print(dic.keys())
	patterns = []

	
	for pat in args.pattern[0]:
		#print(pat)	
		with open(pat, "r") as file:
		    patternList = file.read().split('\n')
	   

		for pattern in patternList:
			#print(pattern)
			if pattern == '':
				patternList.remove(pattern)
			

		print(patternList)
		#patterns = ["A02010", "A0302"] #example
		for pattern in patternList: 
		    pattern = re.compile(":"+pattern)
		    #print(pattern)
		    for key, value in dic.items():   # iter on both keys and values
			    if pattern.findall(key):
				    new_dic[key] =value
				    fasta.write(str(key) + "\n" + value + "\n")

	fasta.close()
	file.close()
